
/*
+-----------------------------------------------------------------------------------------+
| (C) ADDI-DATA GmbH																		|
+-----------------------------------------------------------------------------------------+
| Tel : +49 (0) 7223/9493-0                   | email    : info@addi-data.com             |
| Fax : +49 (0) 7223/9493-92                  | Internet : http://www.addi-data.com       |
+-----------------------------------------------------------------------------------------+
| Project   : -                               | Compiler : BORLAND C / Visual C++         |
| Modulname : SAMPLE06.C                      | Version  : 5.01 / 5.0                     |
+-----------------------------------------------------------------------------------------+
| Author    : BEUQUE S.                       | Date     : 03.01.2013                     |
+-----------------------------------------------------------------------------------------+
| Description :   - Test 32 digital output									            | 
+-----------------------------------------------------------------------------------------+
| Used functions : - i_ADDIDATA_OpenWin32Driver                           (...) Win32     |
|                  - b_ADDIDATA_GetNumberOfDigitalOutputs                 (...)           |
|                  - b_ADDIDATA_CloseWin32Driver                          (...)   Win32   |
+-----------------------------------------------------------------------------------------+
| Connection suggested :                                                                  |
+-----------------------------------------------------------------------------------------+
| Required connection :                                                                   |
+-----------------------------------------------------------------------------------------+
|                             UPDATE'S                                                    |
+-----------------------------------------------------------------------------------------+
|   Date      |   Author      |          Description of updates                           |
+-----------------------------------------------------------------------------------------+
|03.01.2013   | BEUQUE S.     | Creation                                                  |
+-----------------------------------------------------------------------------------------+
*/

#include <stdio.h>
#include <conio.h>

#ifndef __BORLANDC__
#include "..\include\define.h"
#include "..\include\init.h"
#include "..\include\error.h"
#include "..\include\dig_out.h"
#else
#include "..\include\define.h"
#include "..\..\..\..\init.h"
#include "..\..\..\..\error.h"
#include "..\..\..\..\dig_out.h"
#endif

/***********************/
/**  Global variable  **/
/***********************/

DWORD dw_DriverHandle;

/**********************/
/**  Main programme  **/
/**********************/

void main(void)
{
	/*****************************/
	/**  Declare the variables  **/
	/*****************************/

	INT     i_key;
	BYTE    b_DigitalOutputPort;
	INT     i_ReturnValue;
	INT		onOff;
	BYTE	b_DigitalOutputMemory;
	DWORD	dw_DriverVersion;
	WORD	w_NumberOfChannels;
	/********************************/
	/**  Initialise the variables  **/
	/********************************/

	onOff = 2;
	i_key = 0;

	/********************************/
	/**  Print sample information  **/
	/********************************/

	printf ("\n\n");
	printf ("\n+----------------------------------------------------------------------+");
	printf ("\n| ADDIDATA digital output SAMPLE06:                                    |");
	printf ("\n|    - Test 32 digital output									      |");
	printf ("\n|    - Give the status of the digital outputs if possible.             |");
	printf ("\n+----------------------------------------------------------------------+");
	printf ("\n| Connection suggested : See the technical documentation.              |");
	printf ("\n+----------------------------------------------------------------------+");
	printf ("\n| Required connection : See the technical documentation.               |");
	printf ("\n+----------------------------------------------------------------------+");
	printf ("\n| <ESC> exit sample                                                    |");
	printf ("\n+----------------------------------------------------------------------+");
	printf ("\n| Press any key for start the sample                                   |");
	printf ("\n+----------------------------------------------------------------------+");
	printf ("\n\n");
	getch  ();

	/********************************/
	/**  Open the ADDIDATA Driver  **/
	/********************************/

	i_ReturnValue = i_ADDIDATA_OpenWin32Driver (ADDIDATA_DLL_COMPILER_C,
		&dw_DriverHandle);

	if (i_ReturnValue == 0)
	{
		v_ADDIDATA_GetDriverVersion  (&dw_DriverVersion);
		printf("Driver Version %x\n", dw_DriverVersion);

		i_ReturnValue = b_ADDIDATA_GetNumberOfDigitalOutputs (dw_DriverHandle, &w_NumberOfChannels);

		if (i_ReturnValue == 1)
		{
			printf("Number of digital outputs : %d", w_NumberOfChannels);
			i_ReturnValue = 0;
		}
		else
		{
			printf("Error getting number of digital outputs");
		}
	}



	/*****************************/
	/**  Test the return value  **/
	/*****************************/
	if (0 == i_ReturnValue)
	{
		for(;;)
		{
			printf("\ni_ADDIDATA_OpenWin32Driver Ok.");


			/***************************************************/
			/**  Take the status of the output memory to use  **/
			/***************************************************/

			do
			{
				printf ("\n Do you want to use output memory? (Yes=1, No=0):");
				scanf("%hu",&b_DigitalOutputMemory);

			} while ((b_DigitalOutputMemory < 0) || (b_DigitalOutputMemory > 1));

			if (b_DigitalOutputMemory == 1)
			{
				if (b_ADDIDATA_SetDigitalOutputMemoryOn (dw_DriverHandle))
				{
					printf("\nb_ADDIDATA_SetDigitalOutputMemoryOn Ok.\n");

				}
				else
				{
					printf("\nb_ADDIDATA_SetDigitalOutputMemoryOn Error.\n");

				}
			}


			printf("which port do you want to turn on/off\n");
			scanf("%u", &b_DigitalOutputPort);
			printf("%u\n", b_DigitalOutputPort);
			printf("Do you want to turn this port on<1> or off<0>?");
			do
			{
				scanf ("%u", &onOff);
			}while(onOff > 1 );
			printf("%u\n", onOff);

			if(onOff)
			{
				if (b_ADDIDATA_Set32DigitalOutputsOn (dw_DriverHandle,
					b_DigitalOutputPort,
					0xFFFFFFFF))
				{
					printf("\n\nb_ADDIDATA_Set32DigitalOutputsOn Ok. Value written : %lu", 0xFFFFFFFF);
				}
				else
				{
					printf("\n\nb_ADDIDATA_Set32DigitalOutputsOn Error. Value : %lu", 0xFFFFFFFF);
					break;
				}
			}
			else
			{
				if (b_ADDIDATA_Set32DigitalOutputsOff (dw_DriverHandle,
					b_DigitalOutputPort,
					0))
				{
					printf("\n\nb_ADDIDATA_Set32DigitalOutputsOff Ok. Value written : %lu", 0);
				}
				else
				{
					printf("\n\nb_ADDIDATA_Set32DigitalOutputsOff Error. Value : %lu", 0);
					break;
				}
			}

			if (kbhit ())
			{
				i_key = getch ();

				if (i_key == 27)
				{
					break;
				}
			}
		}
		/*********************************/
		/**  Close the ADDIDATA Driver  **/
		/*********************************/

		if (b_ADDIDATA_CloseWin32Driver (dw_DriverHandle))
		{
			printf("\ni_ADDIDATA_CloseWin32Driver Ok.");

		}
		else
		{
			printf("\ni_ADDIDATA_CloseWin32Driver Error.");

		}
	}
	else
	{
		printf("\ni_ADDIDATA_OpenWin32Driver Error: %d",i_ReturnValue);
	}
	printf ("\n\n");
	printf ("\n+---------------------------------------------------+");
	printf ("\n| Program concluded.                                |");
	printf ("\n+---------------------------------------------------+");
	printf ("\n| Press ESC for exit from sample                    |");
	printf ("\n+---------------------------------------------------+");
	printf ("\n\n");

	/************/
	/* Wait ESC */
	/************/

	for (;;)
	{
		if (kbhit ())
		{
			if (getch () == 27)
			{
				break;

			}
		}
	}
	printf ("\n\n");

}
